<template>
    <div>
        <div class="card mt-4">
            <h3 class="card-header text-center py-4">
                <strong v-if="this.$route.path === '/'">{{risk.name}}</strong>
                <strong v-if="this.$route.path === '/list'">{{risk.risk_type_name}}</strong>
            </h3>
            <form class="mt-2" @submit.prevent="getRiskTypes">
                <component
                    v-for="(field, index) in risk.data"
                    :key="index"
                    :is="field.field_type"
                    v-bind="field"
                    class="form-group row"
                ></component>
                <button
                    v-if="this.$route.path === '/'"
                    type="submit"
                    class="btn btn-primary mb-2"
                >Create</button>
            </form>
        </div>
    </div>
</template>

<script>
import Boolean from "../components/FormFields/Boolean";
import Date from "../components/FormFields/Date";
import Time from "../components/FormFields/Time";
import Number from "../components/FormFields/Number";
import Integer from "../components/FormFields/Integer";
import Float from "../components/FormFields/Float";
import TextLine from "../components/FormFields/TextLine";
import TextArea from "../components/FormFields/TextArea";
import SelectList from "../components/FormFields/SelectList";
import Hidden from "../components/FormFields/Hidden";

import { apiService } from "../common/api.service.js";

export default {
    name: "RiskForm",
    props: ["risk"],
    components: {
        Boolean,
        Date,
        Time,
        Number,
        Integer,
        Float,
        TextLine,
        TextArea,
        SelectList,
        Hidden
    },
    data() {
        return {
            risktypes: []
        };
    },
    methods: {
        getRiskTypes(submitEvent) {
            if (!submitEvent) return;

            this.newRisk = {
                name: "",
                data: []
            };
            let formFields = submitEvent.target.elements;
            for (let i = 0; i < formFields.length; i++) {
                let field = formFields[i];
                if (field.type === "submit") continue;
                if (field.field_name === "risk_name")
                    this.newRisk.name = field.value;
                let fieldData = {};
                fieldData.field_id = field.parentNode.parentNode.getAttribute(
                    "field_id"
                );
                fieldData.field_value = field.value;
                this.newRisk.data.push(fieldData);
            }
            this.newRisk.risk_type = parseInt(formFields[0].value);
            this.newRisk.name = formFields[1].value;
            this.onSubmit();
        },
        onSubmit() {
            // TODO: error checking
            console.log("Submitting new risk: " + JSON.stringify(this.newRisk));
            let endpoint = "api/risks/";
            let method = "POST";
            apiService(endpoint, method, this.newRisk).then(() => {
                this.$router.push({
                    name: "list",
                    params: {}
                });
            });
        }
    },
    created() {
        this.getRiskTypes();
    }
};
</script>

<style>
</style>